package com.github.wikibot.main;

import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import com.github.wikibot.parsing.plwikt.FieldTypes;
import com.github.wikibot.parsing.plwikt.Page;
import com.github.wikibot.utils.Login;
import com.github.wikibot.utils.PageContainer;

public final class Test {
	public static void main(String[] args) throws Exception {
		List<String> titles = Files.readAllLines(Paths.get("./data/temp.txt"));
		System.out.println(titles.size());
		
		Wikibot wb = Login.createSession("pl.wiktionary.org");
		List<PageContainer> pages = wb.getContentOfPages(titles);
		
		final Pattern patt_m = Pattern.compile("\\(\\d+\\.\\d+\\) +\\{\\{polskie +nazwisko +męskie\\}\\}");
		final Pattern patt_f = Pattern.compile("\\(\\d+\\.\\d+\\) +\\{\\{polskie +nazwisko +żeńskie\\}\\}");
		final Pattern patt_num = Pattern.compile("\\(\\d+\\.\\d+\\)");
		
		List<String> res = pages.stream()
			.map(Page::wrap)
			.filter(p -> p.getAllSections().size() == 1)
			.flatMap(p -> p.getPolishSection().stream())
			.flatMap(s -> s.getField(FieldTypes.DEFINITIONS).stream())
			.filter(f -> {
				String content = f.getContent();
				content = patt_m.matcher(content).replaceAll("");
				content = patt_f.matcher(content).replaceAll("");
				return patt_num.matcher(content).results().count() == 0;
			})
			.map(f -> f.getContainingSection().get().getContainingPage().get().getTitle())
			.collect(Collectors.toList());
		
		System.out.println(res.size());
		
		Files.write(Paths.get("./data/temp2.txt"), res, StandardCharsets.UTF_8);
		
		titles.removeAll(res);
		System.out.println(titles.size());
		Files.write(Paths.get("./data/temp3.txt"), titles, StandardCharsets.UTF_8);
	}
}
