package com.github.wikibot.main;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.wikipedia.Wiki;
import org.wikiutils.ParseUtils;

import com.github.wikibot.utils.Login;
import com.github.wikibot.utils.PageContainer;

public final class Test {
	public static void main(String[] args) throws Exception {
		Wikibot wb = Login.createSession("pl.wiktionary.org");
		List<String> titles = Files.readAllLines(Paths.get("./data/temp2.txt"));
		Set<String> set = new HashSet<>(titles);
		
		final String summary = "odlinkowanie usuniętych nazwisk w {{podobne}}";
		
		for (List<String> wlh : wb.whatLinksHere(titles, false, false, Wiki.MAIN_NAMESPACE)) {
			if (wlh.isEmpty()) {
				continue;
			}
			
			for (PageContainer pc : wb.getContentOfPages(wlh)) {
				String content = pc.getText();
				
				for (String template : ParseUtils.getTemplates("podobne", pc.getText())) {
					HashMap<String, String> params = ParseUtils.getTemplateParametersWithValue(template);
					params.values().removeIf(set::contains);
					
					if (params.size() != 1) {
						content = content.replace(template, ParseUtils.templateFromMap(params));
					} else {
						content = content.replace(template + "\n", "").trim();
					}
				}
				
				if (!content.equals(pc.getText())) {
					wb.edit(pc.getTitle(), content, summary, pc.getTimestamp());
				}
			}
		}
	}
}
